import java.io.*;
import java.util.*;

public class chiSquare {


    public static void main(String[] args) {

		//Create map index of all tags in location c
		Map<String, Integer> glossary = new HashMap<String, Integer>();
		//Create map index of all tags in entire dataset
		Map<String, Integer> totalTags = new HashMap<String, Integer>();
		int allTagsSize = 0;
		int locationTagsSize = 0;

		try {
			//Read in location c's tag cluster
			String allTags = new Scanner ( new File ("locationTags.txt") ).useDelimiter("\\Z").next();
			//Read in all location's combined tag cluster
			String indexTags = new Scanner ( new File ("totalTags.txt") ).useDelimiter("\\Z").next();

			//Split tags seperated by comma
			String[] splitTags = allTags.split(",");
			String[] splitAllTags = indexTags.split(",");

			//find number of comma delimited tags in each data set
			locationTagsSize = splitTags.length;
			allTagsSize = splitAllTags.length;
			System.out.println("\n"+"Total number of tags for entire dataset: " + allTagsSize);

			//Loop through each dataset populating hashmap with tags & corresponding counts
			for (int i = 0; i < splitTags.length - 1; i++) {
				String key = splitTags[i];
				key = (key.toLowerCase()).trim();
				if (glossary.containsKey(key)) {
					glossary.put(key, Integer.parseInt(glossary.get(key).toString()) + 1);
				} else {
					glossary.put(key, 1);
				}
			}
			for (int j = 0; j < splitAllTags.length - 1; j++) {
				String key = splitAllTags[j];
				key = (key.toLowerCase()).trim();
				if (totalTags.containsKey(key)) {
					totalTags.put(key, Integer.parseInt(totalTags.get(key).toString()) + 1);
				} else {
					totalTags.put(key, 1);
				}
			}}catch (FileNotFoundException e) {
			System.out.println("Error!");
		}
		orderMaps(glossary, totalTags, allTagsSize, locationTagsSize);
	}




	//Function to turn glossaries into ordered sequences
	//**************************************************************************************************
	//Source: http://stackoverflow.com/questions/109383/how-to-sort-a-mapkey-value-on-the-values-in-java
	//**************************************************************************************************
	public static void orderMaps(Map<String, Integer> glossary, Map<String, Integer> totalTags, int allTagsSize, int locationTagsSize) {
	List list = new LinkedList(glossary.entrySet());
	List list2 = new LinkedList(totalTags.entrySet());

	//Sort List based on comparator
	Collections.sort(list, new Comparator() {
		public int compare(Object instance1, Object instance2) {
			return (-1) * ((Comparable) ((Map.Entry) (instance1)).getValue())
			.compareTo(((Map.Entry) (instance2)).getValue());
		}
	});/*
	Collections.sort(list2, new Comparator() {
				public int compare(Object instance1, Object instance2) {
					return (-1) * ((Comparable) ((Map.Entry) (instance1)).getValue())
					.compareTo(((Map.Entry) (instance2)).getValue());
				}
	});*/

	//Put sorted list into map again
	Map sortedMap = new LinkedHashMap();
	for (Iterator it = list.iterator(); it.hasNext();) {
		Map.Entry entry = (Map.Entry) it.next();
		sortedMap.put(entry.getKey(), entry.getValue());
	}/*
	Map totalTagsMap = new LinkedHashMap();
	for (Iterator it = list2.iterator(); it.hasNext();) {
		Map.Entry entry = (Map.Entry) it.next();
		totalTagsMap.put(entry.getKey(), entry.getValue());
	}
	//System.out.println(sortedMap.toString()); */
	calcChiSquare(sortedMap, totalTags, allTagsSize, locationTagsSize);
    }






	public static void calcChiSquare(Map<String, String> locationC, Map<String, Integer> allUK, int allTagsSize, int locationTagsSize){
	//Write results to output csv file
	BufferedWriter writer = null;
	int tagCounter = 0;
	String totalCounts = "";
	int ObservedFrequency = 0;
	double ExpectedFrequency = 0.0;
	double chiSquare = 0.0;
	int o1, o2, o3  = 0;
	double chiSquare2, chiSquare3, chiSquare4, chiSquaredFormula = 0;


		try
			{
				writer = new BufferedWriter( new FileWriter("Results.csv"));
				//Initialise column headings in CSV file
				writer.write("Tags" + "," + "Observed_Frequency" + "," + "Counts_In_All_Data" + "," + "Expected_Frequency" + "," + "Chi_Squared_Total");
				writer.newLine();

				//Calculate first part of chi-square formula
				//Iterate over location c map and get observed frequency value
				Iterator iterator = locationC.entrySet().iterator();
				while (iterator.hasNext()) {
					Map.Entry tagC = (Map.Entry)iterator.next();
					ObservedFrequency = ((Integer) tagC.getValue());
					tagCounter += ObservedFrequency;

					//Match tag keys from location c and all data - calculate expected frequency values
					Iterator it = allUK.entrySet().iterator();
					while (it.hasNext()) {
						Map.Entry tagUK = (Map.Entry)it.next();
						if ((tagUK.getKey()).equals(tagC.getKey())){
							totalCounts = tagUK.getValue().toString();
							ExpectedFrequency = ((Double.parseDouble(totalCounts)*locationTagsSize)/allTagsSize);
							try {
								chiSquare = (ObservedFrequency-ExpectedFrequency)*(ObservedFrequency-ExpectedFrequency);
								chiSquare = chiSquare / ExpectedFrequency;
							}
							catch (ArithmeticException e) {
								System.out.println("Exception caught: Division by zero.");
							}
						}
					}

					//Calculate rest of chi-square formula

					//Probability of tag t occuring in any location -> total occurence of tag / total number of tags in all data
					float Pt = (Float.parseFloat(totalCounts)) / allTagsSize;
					//Probability of tag occuring in this location -> total tags in location / total of all tags
					float Pc = ((float) locationTagsSize) / allTagsSize;

					//number of tags that arent t that appear in location c
					o1 = locationTagsSize - ObservedFrequency;
					double e1 = allTagsSize * (1-Pt) * Pc;
					double chi1 = ((o1 - e1) * (o1 - e1)) / e1;

					//Number of times tag t appears outside location c
					o2 =  (Integer.parseInt(totalCounts)) - ObservedFrequency;
					double e2 = allTagsSize * (Pt) * (1-Pc);
					double chi2 = ((o2 - e2) * (o2 - e2)) / e2;

					//Number of tags that appear outside c that are not t
					o3 = (allTagsSize - locationTagsSize) - ((Integer.parseInt(totalCounts)) - ObservedFrequency);
					double e3 = allTagsSize * (1-Pt) * (1-Pc);
					double chi3 = ((o3 - e3) * (o3 - e3)) / e3;

					//Sum the total of each of the four parts to the chi square formula
					double chiSquareTotal = chiSquare + chi1 + chi2 + chi3;

					//Output results with tag and corresponding values as individual rows
					writer.write(tagC.getKey() + "," + ObservedFrequency + "," + totalCounts + "," + ExpectedFrequency + "," + chiSquareTotal);
					writer.newLine();

			}

			System.out.println("\n"+"Total number of tags counted for this location: " + tagCounter);
			System.out.println("\n"+"File successfully created, saved as 'results.csv'");
			} catch ( IOException e){}
			finally
			{
				try
				{
					if ( writer != null)
					writer.close( );
				}
				catch ( IOException e){}
			}
	}
}