 var locations = [
    "Blackpool, UK", "Cardiff, UK"];
        
var scraped = {};
//var pageNum = 1;
var locationName = "";

//setup url prefix and api_key for use with requests
var flickr = {
  url: 'http://api.flickr.com/services/rest/',
  api_key: '7c9075639b7d1b966a13aff10a704e92',
};

//function for constructing correct url for JSON request
var buildUrl = function (method, query) {
  var url = flickr.url+"?method=flickr."+method+"&api_key="+flickr.api_key;
  for (key in query)
    url += '&' + key + '=' + query[key];
    url += "&format=json&nojsoncallback=1";
  return url;
};

//Execute functions when button on html is clicked
$("#send").click(function(event){
    event.preventDefault();
    $('#tagbox').show();


    //setup variables with input taken from entry boxes
    var dateFrom = $('#dateFrom').val();
    var dateTo = $('#dateTo').val();



    //Get corresponding place id's for all search location
        $.each(locations, function(key, place) {
            var url = buildUrl('places.find', {query: place});
            console.log('initialising location: ' + place);
			var pageNum = 1;
            locationName = place;
            $.getJSON(url).done(function (data) {
                getPhotos(data.places.place[0].place_id, pageNum);
            });
        });


    //Get photos matching place id and date taken
        var getPhotos = function(place_id, pageNum) {
            console.log('getting photos for: ' + place_id);
            var url = buildUrl('photos.search', {place_id: place_id, min_upload_date: dateFrom, 
					per_page: '500', max_upload_date: dateTo, safe_search: '3', page: pageNum});

            console.log(url);
            scraped[place_id] = {};

            $.getJSON(url).done(function (data) {
                console.log("Total number of photos in search: " + data.photos.total);
                console.log("Number of pages to scrape photos for: " + data.photos.pages);
                console.log("currently scraping page: " + data.photos.page);
                photosByPage(data, place_id, pageNum);
            });
        };

        var photosByPage = function(data, place_id, pageNum){
            $.each(data.photos.photo, function (key, photo){
                 //console.log("Getting individual tags");
                 getTags(place_id, photo.id, photo.secret);
            });
            if (data.photos.page != data.photos.pages) {
                pageNum +=1;
                getPhotos(place_id, pageNum);
            }
        };



    // gets tags for each photo
        var getTags = function(place_id, photo_id, photo_secret) {
            var url = buildUrl('photos.getInfo', {photo_id: photo_id, photo_secret: photo_secret});
            var currentTags = [];
            $.getJSON(url).done(function(data) {
                //check to see photo exists
                if (data.photo !== undefined){
				
                    //if photo does exist, grab tags and push to array
                    $.each(data.photo.tags.tag, function (key, tag) {
                        currentTags.push(tag.raw);
                    });
                    scraped[place_id][photo_id] = currentTags;
                }
            });


        };

        //Prepare download files for each location when all requests have completed
        $(document).ajaxStop(function () {

            console.log("Begin function to download scraped tags");
            printTags(scraped);

        });

        //encode tag files and download in browser
        var printTags = function(scraped){
		console.log("Downloading tags to machine now");

            var indivLocation = {};
            $.each(scraped, function(index, value){
                indivLocation = value;
                var arr = $.map(indivLocation, function(value, key){
                    return value;
                })

                var tagCluster = (JSON.stringify(arr));
                tagCluster = tagCluster.replace(/[^A-Za-z0-9,&]/g, ' ');
                var a = document.body.appendChild(
                    document.createElement("a")
                );
                a.download = "tagData.txt";
                a.href = "data: text/plain;base64," + btoa(tagCluster);
                a.click();
            });
           // location.reload();
        };
    //}
});


